<!DOCTYPE html>
<html lang="en">
<head>
    <style>
        .simpleTable {
            font-family: Arial, Helvetica, sans-serif;
            border-collapse: collapse;
            width: 100%;
            border: 2px solid;
            margin: 1%;
            float: left;
        }

        .simpleTable td, .simpleTable th {
            border: 1px solid #ddd;
            text-align: center;
            padding: 8px;
        }
    /*
        .simpleTable tr:nth-child(even){
            background-color: #f2f2f2;
        }
     */
        .simpleTable tr:hover {
            background-color: #ddd;
        }

        .simpleTable th {
            padding-top: 12px;
            padding-bottom: 12px;
            background-color: #04AA6D;
            color: white;
        }
    </style>
    <meta charset="UTF-8">
    <title>Simple Data Monitor</title>
</head>
<body>

<header><h1 style="text-align: center;">Simple Data Monitor</h1></header>

<div style="width:100%; height:100%;" >
    <table id="dataTable" class="simpleTable" style="width:70%; height:100%; overflow: auto;">
    </table>
    <table id="valueTable" class="simpleTable" style="width:25%; height:100%; overflow: auto;">
        <thead><th>value</th></thead>
    </table>
</div>

</body>

<script>
    class SortStatus {
        constructor() {
            this.column = 0;
            this.asc = true;
        }
    }
    var sorting = new SortStatus();
    var table_data = {};
    var update_interval;

    function getJsonRequest(url, params, dataHandle) {
        const myUrlWithParams = new URL(url, window.location.href);
        for (const [key, value] of Object.entries(params)) {
            myUrlWithParams.searchParams.append(key, value.toString());
        }
        const myHeaders = new Headers();
        const myRequest = new Request(myUrlWithParams.href, {
            method: 'GET',
            headers: myHeaders,
            mode: 'cors',
            cache: 'default',
        });
        fetch(myRequest)
            .then((response) => {
                if (!response.ok) {
                    throw new Error('Network response was not OK - ' + response.url);
                }
                return response.json();
            })
            .then((myJson) => {
                dataHandle(myJson)
            })
            .catch((error) => {
                console.error('Failed Json Request:', error);
            });
    }

    function updateTableHtml()
    {
        let table_column_data = table_data['columns'];
        let table_row_data = table_data['rows'];
        let table_header;

        const tbl = document.getElementById("dataTable");
        // Create header if it does not exist
        if (tbl.tHead == null)
        {
            table_header = tbl.createTHead();
            for (let i = 0; i < table_column_data.length; i++)
            {
                const column = document.createElement("th");
                column.textContent = table_column_data[i];
                column.onclick = function() { sortTable(i); };
                table_header.append(column)
            }
        }
        table_header = tbl.tHead;
        const table_header_cols = table_header.children
        for (let i = 0; i < table_column_data.length; i++)
        {
            if (sorting.column === i)
            {
                if (sorting.asc)
                {
                    table_header_cols[i].textContent = table_column_data[i] + " " + String.fromCharCode(8595);
                }
                else
                {
                    table_header_cols[i].textContent = table_column_data[i] + " " + String.fromCharCode(8593);
                }
            }
            else
            {
                table_header_cols[i].textContent = table_column_data[i] + "  ";
            }
        }
        // replace existing data
        let replace_count = tbl.rows.length > table_row_data.length ? table_row_data.length : tbl.rows.length;
        // replace existing data
        for (let i = 0; i < replace_count; i++) {
            let row = tbl.rows[i];
            for (let j = 0; j < row.cells.length; j++) {
                row.cells[j].textContent = table_row_data[i][j];
            }
        }
        if (table_row_data.length < tbl.rows.length) {
            for (let i = table_row_data.length; i < tbl.rows.length; i++) {
                tbl.deleteRow(i);
            }
        }
        else if (table_row_data.length > tbl.rows.length) {
            for (let i = tbl.rows.length; i < table_row_data.length; i++) {
                let row = tbl.insertRow(i);
                let row_data = table_row_data[i];
                for (let j = 0; j < row_data.length; j++) {
                    let cell = row.insertCell(j);
                    cell.textContent = row_data[j];
                }
            }
        }
    }

    function sortCompare(a, b)
    {
        if (a[sorting.column] < b[sorting.column]){
            return -1;
        }
        if (a[sorting.column] > b[sorting.column]){
            return 1;
        }
        return 0;
    }

    function sortTable(n) {
        if (n != null)
        {
            if (sorting.column === n) {
                sorting.asc ^= 1;
            }
            else {
                sorting.asc = true;
            }
            sorting.column = n;
        }
        table_data['rows'].sort(sortCompare);
        if (!sorting.asc)
        {
            table_data['rows'].reverse();
        }
        updateTableHtml();
    }

    function updateTableData(jsonData)
    {
        table_data = jsonData;
        sortTable(null);
    }

    function updateTable()
    {
        getJsonRequest('/table', {}, updateTableData);
    }

    document.addEventListener('DOMContentLoaded', (event) => {
        updateTable();
        update_interval = setInterval(updateTable, 5000);
    });

</script>

</html>